/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20220331 (64-bit version)
 * Copyright (c) 2000 - 2022 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of SSDT7, Tue Feb  7 14:33:29 2023
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000008E9 (2281)
 *     Revision         0x02
 *     Checksum         0x06
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "CB-01   "
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("", "SSDT", 2, "LENOVO", "CB-01   ", 0x00000001)
{
    External (_SB_.PCI0.LPCB.EC0_.CHKS, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.LPCB.EC0_.HGCT, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.SMPR, UnknownObj)
    External (P8XH, MethodObj)    // 2 Arguments
    External (UBCB, UnknownObj)
    External (USTC, UnknownObj)
    External (XDCE, UnknownObj)

    Scope (\_SB)
    {
        Device (UBTC)
        {
            Name (_HID, EisaId ("USBC000"))  // _HID: Hardware ID
            Name (_CID, EisaId ("PNP0CA0"))  // _CID: Compatible ID
            Name (_UID, Zero)  // _UID: Unique ID
            Name (_DDN, "USB Type C")  // _DDN: DOS Device Name
            Name (_ADR, One)  // _ADR: Address
            Name (WTMP, Zero)
            Name (RTMP, Zero)
            Name (CRS, ResourceTemplate ()
            {
                Memory32Fixed (ReadWrite,
                    0x00000000,         // Address Base
                    0x00001000,         // Address Length
                    _Y00)
            })
            Method (TPLD, 2, Serialized)
            {
                Name (PCKG, Package (0x01)
                {
                    Buffer (0x10) {}
                })
                CreateField (DerefOf (PCKG [Zero]), Zero, 0x07, REV)
                REV = One
                CreateField (DerefOf (PCKG [Zero]), 0x40, One, VISI)
                VISI = Arg0
                CreateField (DerefOf (PCKG [Zero]), 0x57, 0x08, GPOS)
                GPOS = Arg1
                CreateField (DerefOf (PCKG [Zero]), 0x4A, 0x04, SHAP)
                SHAP = One
                CreateField (DerefOf (PCKG [Zero]), 0x20, 0x10, WID)
                WID = 0x08
                CreateField (DerefOf (PCKG [Zero]), 0x30, 0x10, HGT)
                HGT = 0x03
                Return (PCKG) /* \_SB_.UBTC.TPLD.PCKG */
            }

            Device (CR01)
            {
                Name (_ADR, Zero)  // _ADR: Address
                Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
                {
                    Return (Package (0x04)
                    {
                        0xFF, 
                        0x09, 
                        Zero, 
                        Zero
                    })
                }

                Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
                {
                    Return (TPLD (One, 0x04))
                }
            }

            Method (_CRS, 0, Serialized)  // _CRS: Current Resource Settings
            {
                CreateDWordField (CRS, \_SB.UBTC._Y00._BAS, CBAS)  // _BAS: Base Address
                CBAS = UBCB /* External reference */
                Return (CRS) /* \_SB_.UBTC.CRS_ */
            }

            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If ((USTC == One))
                {
                    Return (0x0F)
                }

                Return (Zero)
            }

            OperationRegion (E9FF, SystemMemory, 0xFF00D980, 0x10)
            Field (E9FF, AnyAcc, Lock, Preserve)
            {
                Offset (0x0C), 
                EC8C,   8
            }

            OperationRegion (USBC, SystemMemory, UBCB, 0x38)
            Field (USBC, ByteAcc, Lock, Preserve)
            {
                VER1,   8, 
                VER2,   8, 
                RSV1,   8, 
                RSV2,   8, 
                CCI0,   8, 
                CCI1,   8, 
                CCI2,   8, 
                CCI3,   8, 
                CTL0,   8, 
                CTL1,   8, 
                CTL2,   8, 
                CTL3,   8, 
                CTL4,   8, 
                CTL5,   8, 
                CTL6,   8, 
                CTL7,   8, 
                MGI0,   8, 
                MGI1,   8, 
                MGI2,   8, 
                MGI3,   8, 
                MGI4,   8, 
                MGI5,   8, 
                MGI6,   8, 
                MGI7,   8, 
                MGI8,   8, 
                MGI9,   8, 
                MGIA,   8, 
                MGIB,   8, 
                MGIC,   8, 
                MGID,   8, 
                MGIE,   8, 
                MGIF,   8, 
                MGO0,   8, 
                MGO1,   8, 
                MGO2,   8, 
                MGO3,   8, 
                MGO4,   8, 
                MGO5,   8, 
                MGO6,   8, 
                MGO7,   8, 
                MGO8,   8, 
                MGO9,   8, 
                MGOA,   8, 
                MGOB,   8, 
                MGOC,   8, 
                MGOD,   8, 
                MGOE,   8, 
                MGOF,   8
            }

            OperationRegion (ECSM, SystemMemory, 0xFF00D460, 0x30)
            Field (ECSM, AnyAcc, Lock, Preserve)
            {
                HMPR,   8, 
                    ,   7, 
                HMDN,   1, 
                HADD,   8, 
                HCMD,   8, 
                HD00,   8, 
                HD01,   8, 
                HD02,   8, 
                HD03,   8, 
                HD04,   8, 
                HD05,   8, 
                HD06,   8, 
                HD07,   8, 
                HD08,   8, 
                HD09,   8, 
                HD0A,   8, 
                HD0B,   8, 
                HD0C,   8, 
                HD0D,   8, 
                HD0E,   8, 
                HD0F,   8, 
                Offset (0x24), 
                HCNT,   8
            }

            Mutex (UBSY, 0x00)
            Method (ECWR, 0, Serialized)
            {
                If ((Acquire (\_SB.PCI0.LPCB.EC0.HGCT, 0xA000) == Zero))
                {
                    Acquire (UBSY, 0xFFFF)
                    \_SB.PCI0.LPCB.EC0.CHKS ()
                    HADD = 0x02
                    Sleep (One)
                    HCMD = 0x06
                    Sleep (One)
                    HD00 = MGO0 /* \_SB_.UBTC.MGO0 */
                    Sleep (One)
                    HD01 = MGO1 /* \_SB_.UBTC.MGO1 */
                    Sleep (One)
                    HD02 = MGO2 /* \_SB_.UBTC.MGO2 */
                    Sleep (One)
                    HD03 = MGO3 /* \_SB_.UBTC.MGO3 */
                    Sleep (One)
                    HD04 = MGO4 /* \_SB_.UBTC.MGO4 */
                    Sleep (One)
                    HD05 = MGO5 /* \_SB_.UBTC.MGO5 */
                    Sleep (One)
                    HD06 = MGO6 /* \_SB_.UBTC.MGO6 */
                    Sleep (One)
                    HD07 = MGO7 /* \_SB_.UBTC.MGO7 */
                    Sleep (One)
                    HD08 = MGO8 /* \_SB_.UBTC.MGO8 */
                    Sleep (One)
                    HD09 = MGO9 /* \_SB_.UBTC.MGO9 */
                    Sleep (One)
                    HD0A = MGOA /* \_SB_.UBTC.MGOA */
                    Sleep (One)
                    HD0B = MGOB /* \_SB_.UBTC.MGOB */
                    Sleep (One)
                    HD0C = MGOC /* \_SB_.UBTC.MGOC */
                    Sleep (One)
                    HD0D = MGOD /* \_SB_.UBTC.MGOD */
                    Sleep (One)
                    HD0E = MGOE /* \_SB_.UBTC.MGOE */
                    Sleep (One)
                    HD0F = MGOF /* \_SB_.UBTC.MGOF */
                    Sleep (One)
                    HCNT = 0x10
                    Sleep (One)
                    HMPR = 0x08
                    EC8C = 0x08
                    P8XH (Zero, 0xEF)
                    \_SB.PCI0.LPCB.EC0.CHKS ()
                    HADD = 0x02
                    Sleep (One)
                    HCMD = 0x04
                    Sleep (One)
                    HD00 = CTL0 /* \_SB_.UBTC.CTL0 */
                    Sleep (One)
                    HD01 = CTL1 /* \_SB_.UBTC.CTL1 */
                    Sleep (One)
                    HD02 = CTL2 /* \_SB_.UBTC.CTL2 */
                    Sleep (One)
                    HD03 = CTL3 /* \_SB_.UBTC.CTL3 */
                    Sleep (One)
                    HD04 = CTL4 /* \_SB_.UBTC.CTL4 */
                    Sleep (One)
                    HD05 = CTL5 /* \_SB_.UBTC.CTL5 */
                    Sleep (One)
                    HD06 = CTL6 /* \_SB_.UBTC.CTL6 */
                    Sleep (One)
                    HD07 = CTL7 /* \_SB_.UBTC.CTL7 */
                    Sleep (One)
                    HCNT = 0x08
                    Sleep (One)
                    HMPR = 0x08
                    EC8C = 0x08
                    P8XH (Zero, 0xEE)
                    Sleep (One)
                    \_SB.PCI0.LPCB.EC0.CHKS ()
                    Release (UBSY)
                    Release (\_SB.PCI0.LPCB.EC0.HGCT)
                }
            }

            Method (ECRD, 0, Serialized)
            {
                If ((Acquire (\_SB.PCI0.LPCB.EC0.HGCT, 0xA000) == Zero))
                {
                    Acquire (UBSY, 0xFFFF)
                    \_SB.PCI0.LPCB.EC0.CHKS ()
                    HADD = 0x02
                    Sleep (One)
                    HCMD = 0x05
                    Sleep (One)
                    HCNT = 0x10
                    Sleep (One)
                    HMPR = 0x07
                    EC8C = 0x07
                    P8XH (Zero, 0xED)
                    Sleep (One)
                    \_SB.PCI0.LPCB.EC0.CHKS ()
                    MGI0 = HD00 /* \_SB_.UBTC.HD00 */
                    Sleep (One)
                    MGI1 = HD01 /* \_SB_.UBTC.HD01 */
                    Sleep (One)
                    MGI2 = HD02 /* \_SB_.UBTC.HD02 */
                    Sleep (One)
                    MGI3 = HD03 /* \_SB_.UBTC.HD03 */
                    Sleep (One)
                    MGI4 = HD04 /* \_SB_.UBTC.HD04 */
                    Sleep (One)
                    MGI5 = HD05 /* \_SB_.UBTC.HD05 */
                    Sleep (One)
                    MGI6 = HD06 /* \_SB_.UBTC.HD06 */
                    Sleep (One)
                    MGI7 = HD07 /* \_SB_.UBTC.HD07 */
                    Sleep (One)
                    MGI8 = HD08 /* \_SB_.UBTC.HD08 */
                    Sleep (One)
                    MGI9 = HD09 /* \_SB_.UBTC.HD09 */
                    Sleep (One)
                    MGIA = HD0A /* \_SB_.UBTC.HD0A */
                    Sleep (One)
                    MGIB = HD0B /* \_SB_.UBTC.HD0B */
                    Sleep (One)
                    MGIC = HD0C /* \_SB_.UBTC.HD0C */
                    Sleep (One)
                    MGID = HD0D /* \_SB_.UBTC.HD0D */
                    Sleep (One)
                    MGIE = HD0E /* \_SB_.UBTC.HD0E */
                    Sleep (One)
                    MGIF = HD0F /* \_SB_.UBTC.HD0F */
                    Sleep (One)
                    \_SB.PCI0.LPCB.EC0.CHKS ()
                    HADD = 0x02
                    Sleep (One)
                    HCMD = 0x03
                    Sleep (One)
                    HCNT = 0x04
                    Sleep (One)
                    HMPR = 0x07
                    EC8C = 0x07
                    P8XH (Zero, 0xEC)
                    Sleep (One)
                    \_SB.PCI0.LPCB.EC0.CHKS ()
                    CCI0 = HD00 /* \_SB_.UBTC.HD00 */
                    Sleep (One)
                    CCI1 = HD01 /* \_SB_.UBTC.HD01 */
                    Sleep (One)
                    CCI2 = HD02 /* \_SB_.UBTC.HD02 */
                    Sleep (One)
                    CCI3 = HD03 /* \_SB_.UBTC.HD03 */
                    Sleep (One)
                    \_SB.PCI0.LPCB.EC0.CHKS ()
                    Release (UBSY)
                    Release (\_SB.PCI0.LPCB.EC0.HGCT)
                }
            }

            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                If ((Arg0 == ToUUID ("6f8398c2-7ca4-11e4-ad36-631042b5008f") /* Unknown UUID */))
                {
                    Switch (ToInteger (Arg2))
                    {
                        Case (Zero)
                        {
                            Return (Buffer (One)
                            {
                                 0x0F                                             // .
                            })
                        }
                        Case (One)
                        {
                            If ((\_SB.UBTC.WTMP > 0x04))
                            {
                                ECWR ()
                            }
                            Else
                            {
                                \_SB.UBTC.WTMP = (\_SB.UBTC.WTMP + One)
                            }

                            Sleep (0x0A)
                            P8XH (Zero, 0xE0)
                        }
                        Case (0x02)
                        {
                            If ((\_SB.UBTC.RTMP > 0x04))
                            {
                                ECRD ()
                            }
                            Else
                            {
                                \_SB.UBTC.RTMP = (\_SB.UBTC.RTMP + One)
                            }

                            Sleep (0x0A)
                            P8XH (Zero, 0xE1)
                        }
                        Case (0x03)
                        {
                            Return (XDCE) /* External reference */
                        }

                    }
                }

                Return (Buffer (One)
                {
                     0x00                                             // .
                })
            }
        }
    }
}

